<%  
' Search.asp: Search initiation and results page for the Exchange sample page.
'
' Main sections:
'   Page Setup: Sets up include files and HTML layout.
'   Search Initiation: Displays search form. 
'   Search Results: Displays search results and link to "More Results." 
'   Debug Information: Information will be displayed if DEBUGINFO=true or
'     if the query string includes debug=true.
%>

<% ' Page Setup Section. %>
<% Response.expires = 0 %> 
<% DEBUGINFO=false %>
<%' Microsoft Exchange messages are opened from the results page.
   ' OWA     All links to Exchange messages will use OWA. 
   '         Use this only if Outlook Web Access is installed on your 
   '         Exchange server.
   ' Outlook All links to Exchange messages will use Outlook. 
   '         Use this only if your clients
   ' both    Two links will be presented for all Exchange messages: one for 
   '         Outlook, and one for Outlook Web Access.
ExchangeViewer = "both"   
' Set the ExchangeViewer variable. This variable controls how 
%>
<% ' When linking to Outlook Web Access, open the link in a new window. %>
<script language="Javascript">
function openNewWindow(fileName,theWidth,theHeight) {
	window.open(fileName,"NewWindow","toolbar=0,location=0,directories=0,status=1,menubar=1,scrollbars=1,resizable=1,width="+theWidth+",height="+theHeight)
}
</script>

<html>
<% L_SampleName_text = "Exchange Search Sample Page" %>
<head><title><% = L_SampleName_Text %></title></head>
<body BACKGROUND="back.jpg"><font face="arial, helvetica" size=2>


<table Bgcolor="black" width=50%>
<tr>
	<td >	
	<img src="header2.gif"
	</TD>
</tr>
</table>
<hr>

<% ' End of Page Setup Section. %>

<% ' Process Input Section. %>
<% if Request.QueryString <> "" then %> 
  <% ' Initialize or set non-predefined variables from information posted to page.
     ' Purpose of DisplayText variable is to have just the words from the query for 
     '  display in the introductory sentence and in the more results link.
      if Request("DisplayText")= "" then 
        DisplayText= Request("q1")   
      else 
        DisplayText = Request("DisplayText") 
      end if 

     ' Purpose of RecordNum variable is to display which records 
     ' are displayed on each results page.
      if Request("RecordNum") = "" then
        RecordNum=1
      else
        RecordNum=Request("RecordNum")
      end if 

     ' Purpose of session variables is to store information for use in
     ' editing a search. Only information from the initial query is stored:
     ' these variables are not updated on "more results" pages.
     ' If you add additional search criteria in your search page, make sure
     ' to add their initial value to the Session object.
     ' Server.HTMLEncode is required to store queries with double quotes.
      if Request("sh") = "" then
        Session("q1")=Server.HTMLEncode(Request("q1"))
        Session("q2")=Request("q2") 
        Session("ct")=Request("ct")
	Session("c3")=Request("c3")
	Session("o3")=Request("o3")	
	Session("q3")=Request("q3")
	Session("o4")=Request("o4")
	Session("q4")=Request("q4")
	Session("c5")=Request("c5")
	Session("q5")=Request("q5")
	Session("c6")=Request("c6")
	Session("q6")=Request("q6")
	Session("c7")=Request("c7")
	Session("q7")=Request("q7")
	Session("c8")=Request("c8")
	Session("q8")=Request("q8")
	Session("c9")=Request("c9")
	Session("q9")=Request("q9")
      end if 
      ' Read session object into variables.
        q1=Session("q1")
        q2=Session("q2")
        ct=Session("ct")
	c3=Session("c3")
	o3=Session("o3")
	q3=Session("q3")
	o4=Session("o4")
	q4=Session("q4")
	c5=Session("c5")
	q5=Session("q5")
	c6=Session("c6")
	q6=Session("q6")
	c7=Session("c7")
	q7=Session("q7")
	c8=Session("c8")
	q8=Session("q8")
	c9=Session("c9")
	q9=Session("q9")
      
%>
<% end if %>

<% ' Search Initiation Section. 
  ' Show the search form. If the search is being edited, read the information
  ' that has been previously stored in the Session object.
%>
   <p>

   <table cellpadding=5 border=0>
     <form action="Search.asp" method="get">
     <tr>
       <td nowrap><font size=2>
         <% L_QueryLabel_text = "Search for:" %>
         <% = L_QueryLabel_Text %>&nbsp;
         </font>
        </td>
        <td>
         <input type="text" name="q1" size="25" maxlength="100" value="<% = q1 %>">
        </td>
        <td width=5></td>
        <td>
         <% 
         ' Author
         L_AuthorLabel_text = "Sent by"  
         %>
         <font size=2><% = L_AuthorLabel_text %>:</font>
        </td>

        <td>
         <input type="hidden" name="c2" value="@DocAuthor">
         <input type="text" maxlength=100 size=25 name="q2" value="<% = q2 %>">

        </td></tr>
        <tr>
        <td>
        <font size=2>
        Sent in the last:
        </font>
        </td>
        <td>
        <input type=hidden name="c3" value="@filewrite"> 
        <input type=hidden name="o3" value=">="> 
        <select name="q3">
        <option value="" <%if Request("q3")="" then %>selected<%end if%> >
        <option value="-1d" <%if q3="-1d" then %>selected<%end if%> >day
        <option value="-1w" <%if q3="-1w" then %>selected<%end if%> >week
        <option value="-1m" <%if q3="-1m" then %>selected<%end if%> >month
        <option value="-1y" <%if q3="-1y" then %>selected<%end if%> >year
        </select>
        </td>
        <td></td>
        <td><font size=2>
        Sent to: (alias)
        </font></td>
       <td>
	<input type=hidden name=c5 value="@MessageEmailAddress">
        <input type=text name=q5 size=25 maxlength=50 value="<% = q5 %>">
        </td>
        </tr>
        <tr><td>
        <font size=2>Subject:</font>
        </td>
        <td>
        <input type=hidden name="o4" value="@DocTitle"> 
        <input type=text name="q4" size=25 maxlength=50 value="<% = q4 %>">
        </td>
        <td></td>
        <td><font size=2>
        Folder: 
        </font></td>
        <td>

		<input type=hidden name="c6" value="@MessageFolder"> 
        	<input type=hidden name="q6" size=25 maxlength=50 value="<% = q6 %>"> 
		<select name="ct" value="ct">

<% ' Enter New Catalog Names here.
%>

		<!-- Use the following syntax for to search all catalogs
		<option value="Discussion,ProductKnowledge,Business,list_Servers"> All Indexed Folders
		-->
		<!-- You need to put your catalog name here -->
		<option value="Discussion"> \Discussion
		

		</Select>
        </td>
        </tr>

        <tr>

	<!-- Add search by Category -->
        <td><font size=2>
        Category: 
        </font></td>
	<td><input type=hidden name="c7" value="@META_Type"> 
        <select name="q7">
        <option value="" <%if q7="" then %>selected<%end if%> >
        <option value="Best Practice" <%if q7="Best Practice" then %>selected<%end if%> >Best Practice
        <option value="Idea" <%if q7="Idea" then %>selected<%end if%> >Idea
        <option value="Issue" <%if q7="Issue" then %>selected<%end if%> >Issue
        <option value="Resolution" <%if q7="Resolution" then %>selected<%end if%> >Resolution
        </select>
        
	</td>
	<td></td>
	
	<!-- Add Search by Industry -->
        <td><font size=2>
        Industry: 
        </font></td>
	<td><input type=hidden name="c8" value="@META_Industry"> 
        <select name="q8">
        <option value="" <%if q8="" then %>selected<%end if%> >
        <option value="Communication and Entertainment" <%if q8="Communication and Entertainment" then %>selected<%end if%> >Communication and Entertainment
        <option value="Distributed Services" <%if q8="Distributed Services" then %>selected<%end if%> >Distributed Services
        <option value="Financial Services" <%if q8="Financial Services" then %>selected<%end if%> >Financial Services
        <option value="Government" <%if q8="Government" then %>selected<%end if%> >Government
        <option value="Healthcare" <%if q8="Healthcare" then %>selected<%end if%> >Healthcare
        <option value="Information Systems(Hardware/Software)" <%if q8="Information Systems(Hardware/Software)" then %>selected<%end if%> >Information Systems(Hardware/Software)
        <option value="Manufacturing" <%if q8="Manufacturing" then %>selected<%end if%> >Manufacturing
        <option value="Professional Services" <%if q8="Professional Services" then %>selected<%end if%> >Professional Services
        <option value="Transportation" <%if q8="Transportation" then %>selected<%end if%> >Transportation
        </select>
	</td> 
	</TR>
	<TR>
	
	<!-- Add Search by Product -->
        <td><font size=2>
        Product: 
        </font></td>
	<td><input type=hidden name="c9" value="@META_Product"> 
        <select name="q9">
        <option value="" <%if q9="" then %>selected<%end if%> >
        <option value="(Other)" <%if q9="(Other)" then %>selected<%end if%> >(Other)
        <option value="Access" <%if q9="Access" then %>selected<%end if%> >Access
        <option value="Excel" <%if q9="Excel" then %>selected<%end if%> >Excel
        <option value="Exchange Server" <%if q9="Exchange Server" then %>selected<%end if%> >Exchange Server
        <option value="Mail" <%if q9="Mail" then %>selected<%end if%> >Mail
        <option value="Office" <%if q9="Office" then %>selected<%end if%> >Office
        <option value="Outlook" <%if q9="Outlook" then %>selected<%end if%> >Outlook
        <option value="PowerPoint" <%if q9="PowerPoint" then %>selected<%end if%> >PowerPoint
        <option value="Visual Basic" <%if q9="Visual Basic" then %>selected<%end if%> >Visual Basic
        <option value="Visual C++" <%if q9="Visual C++" then %>selected<%end if%> >Visual C++
        <option value="Word" <%if q9="Word" then %>selected<%end if%> >Word
	</select>
	</td> 
	
       <td colspan=5 align=right>
 
       <% ' Links to tips and search button. 
          L_SearchButton_label = "Search" 
          L_SearchTips_link = "Tips" 
       %>
         &nbsp;&nbsp;&nbsp;
         <input type="submit" value="<% = L_SearchButton_label %>">
         &nbsp;&nbsp;&nbsp;
		 <font size=2><a href="tips.htm"><% = L_SearchTips_link %></a>
         </font>
		</td>
		
		
		
     </tr>
   </table>
  </form>  
<% ' End of Search Initiation Section. %>


<% ' Search Results Section. %>

<% if Request.QueryString <> "" then %> 
<%
' If site visitors use Outlook to view Microsoft Exchange messages,
'  the Exciol control is installed on their computer.
if ExchangeViewer="both" or ExchangeViewer="outlook" then %>
<object id="Exciol" height=0 width=0
 CLASSID="CLSID:DAFD7A40-73FF-11D1-A811-00AA006EAC9D"
 CODEBASE="/siteserver/knowledge/search/controls/exciol.ocx#version=5,5,2148,0"
 TYPE="application/x-oleobject">
</object>

<script language="vbscript">
  Sub DisplayMsg(EntryID)
    Exciol.DisplayMsg(EntryID)
  End Sub
</script>
<% end if %>
<% if ExchangeViewer="both" or ExchangeViewer="owa" then %>
<% ' When linking to Outlook Web Access, open the link in a new window. %>
<script language="Javascript">
function openNewWindow(fileName,theWidth,theHeight) {
  window.open(fileName,"NewWindow","toolbar=0,location=0,directories=0,status=1,menubar=1,scrollbars=1,resizable=1,width="+theWidth+",height="+theHeight)
}
</script>
<% end if %>


   <% ' Set query object properties.
      set Q = Server.CreateObject("MSSearch.Query") 
      ' Define all required query properties: the query itself, and all columns
      ' that will be used in the results. 
      Q.SetQueryFromURL(Request.QueryString)
      Q.Catalog = request("ct") 
      Q.OptimizeFor="nohitcount,performance"
      Q.MaxRecords = 10
      Q.Columns = "DocAuthor, DocTitle, DocAddress, Description, Size, FileWrite"
   %>

<% ' The following debug information is useful as you extend this sample page.
   ' Set DEBUGINFO to true to see what is being passed to this page, and the
   ' resulting query property setting.
%>
<% if DEBUGINFO=true or Request("debug") <> "" then %>
  <p>
  <table cellpadding=5 border=1 bgcolor="EEEEEE">
  <tr><td>
  <b>Useful Debug Information</b><font size=2>
   <p><b>QueryString passed to this page:</b>
      <br><% = Request.QueryString %>
   <p><b>Query:</b> <% = Q.Query %>
   <p><b>Catalogs:</b> <% = Q.Catalog %>
  </font></td></tr>
  </table>
<% end if %>
<hr>

   <% ' Create the recordset holding the search results.
      on error resume next
      set RS = Q.CreateRecordSet("sequential") 
      if err <> 0 then
        createerror = err.description
      end if

   ' Log query for reporting with the Site Server Analysis feature of 
   ' Microsoft Site Server. Only log query for first page of search results.
   '  if Q.StartHit = "" and Session("q1") <> "" then 
   '    InfoToLog = "&MSS.request.Search Catalog=" & Q.Catalog &  _
   '      "&MSS.request.Search Start Hit=0" & _
   '      "&MSS.request.Search Query="& Session("q1")
   '    if err or (RS.EOF and RS.BOF) then
   '      InfoToLog = InfoToLog & "&MSS.request.Search Row Count=0"
   '    else
   '      InfoToLog = InfoToLog & "&MSS.request.Search Row Count=0" 
   '    end if
   '    ' Information to be appended cannot contain commas or spaces.
   '    InfoToLog = Replace(InfoToLog, " ", "%20")
   '    InfoToLog = Replace(InfoToLog,",","+")
   '    Response.AppendToLog InfoToLog
   '  end if


   ' If the query can't be executed, print out the error description.
     if err then 
       Response.write "&nbsp;&nbsp;" & createerror 

   ' If no matches are found, display a message.
     elseif RS.BOF and RS.EOF then
       Response.write "<p>" 
        if Q.QueryIncomplete=true then
          L_TooComplex_Error = "The query is too complex. Try using a simpler query. For information on search syntax, see <a href=tips.htm>Search Tips</a>."
          Response.write L_TooComplex_Error & "<p>"
        else
          L_NoMatch_Error = "No messages matching your query were found. For suggestions on how to broaden your search, see <a href=tips.htm>Search Tips</a>."
          Response.write L_NoMatch_Error & "<p>"
	  ' Display link for a new search. 
	  L_NewSearch_link = "New Search"
	  %>
	  &nbsp;&nbsp;<a href="Search.asp"><% = L_NewSearch_Link %></a>
	  <%
        end if

     else ' If query could be executed, display results. 

      ' Set up the table for displaying results. 
%>
        <table cellpadding=0>
          <tr>
            <td colspan=2><font size=2>
    
              <% ' Make introductory sentences match the information displayed.
                 if Request("sh") = "" then 
                   L_Match_text = "Here are the messages found matching the query" 
                 else
                   L_Match_text = "Here are more messages found matching the query" 
                 end if
                 Response.write L_Match_text & "<b> " & DisplayText & "</b>."
               %>
               <br>&nbsp;
		<% if ExchangeViewer="both" then 
                  L_OWA_Info = "For Microsoft&reg; Exchange messages, click the author's name to view the message using Microsoft Outlook. Click the <img src=html.gif width=16 height=16 border=0 align=middle align=middle> icon to view the message using Microsoft Outlook Web Access."
                  Response.write L_OWA_Info
               end if %>
               <br>&nbsp;
    </font></td>
  </tr>
</table>


<table cellpadding=0 cellspacing=0> 
<tr bgcolor=cccccc>

<% 

L_KBytes_text = "KB" 
L_Received_text = "Received" 
L_Subject_text = "Subject" 
L_Size_text = "Size" 
L_From_text = "From" 

%>
<td></td>
<td><font size=2><b><% = L_From_text %></b></font></td>
<td></td>
<td><font size=2><b><% = L_Subject_text %></b></font></td>
<td></td>
<td><font size=2><b><% = L_Received_text %></b></font></td>
<td></td>
<td><font size=2><b><% = L_Size_text %></b></font></td>
<td></td>

</tr>
<%    
' Set up loop to iterate through results.
  Do while not RS.EOF 

     ' Determine format type, set up title for and URL for links.
       if InStr(RS("MimeType"), "text/exch") then 
         DocType="exchange"
       else
         DocType="doc"
       end if 

  ' If message title is blank, use "No subject" instead.
    if RS("DocTitle") <> "" then   
      Title = RS("DocTitle")
    else
      L_Untitled_text = "No subject" 
      Title = L_Untitled_text
    end if

   ' Provide alternate text if no author exists. HTMLEncode is
   ' required to handle author fields with < or >.
     if RS("DocAuthor") <> "" then 
       Author = Server.HTMLEncode(RS("DocAuthor"))
     else
       L_NoAuthor_text = "Author unknown"
       Author = L_NoAuthor_text
     end if

     ' Set up link itself. Link depends on whether item is document or 
     ' Microsoft exchange message.
     if DocType="doc" then
        Link = RS("DocAddress")
        Image = "html.gif"
     elseif DocType="exchange" then
        Image = "owa.gif"
        if ExchangeViewer="owa" then
          Link = "JavaScript:self.openNewWindow(" & chr(34) & RS("DocAddress") & "&usemainwnd=1" & chr(34) & ", 640,500)" 
        elseif ExchangeViewer="outlook" or ExchangeViewer="both" then
          Link = "VBScript:self.DisplayMsg(" & chr(34) & RS("DocAddress") & "=1" & chr(34) & ")"
        end if
        if ExchangeViewer="both" then
          OWALink = "JavaScript:self.openNewWindow(" & chr(34) & RS("DocAddress") & "&usemainwnd=1" & chr(34) & ", 640,500)" 
        end if
     end if

%>

<% ' Create table row for each result. %> 
<tr><td>&nbsp;</td></tr>
  <tr>
    <% if DEBUGINFO=true or Request("debug") <> "" then %>
       <% ' Display column with record number. %>
            <td valign=top><font size=2><% = RecordNum %>.</font></td>
    <% end if %>
    <td valign=top>
      <a href='<% = Link %>'><img src="<% = Image %>" hspace=6 border=0></a>
    </td>
    <td width=20% valign=top><font size=2>
      <a href='<% = Link %>'><b><% = Author %></b></a> 
     <% if ExchangeViewer = "both" and DocType="exchange" then %>
        <a href='<% = OWALink %>'><img src="html.gif" height=16 width=16 border=0 align=top></a>
     <% end if %>
    </font></td>
    <td width=5>&nbsp;</td>
    <td width=55% valign=top><font size=2>
      <b><% = Title %></b> 
    </font></td>
    <td width=5>&nbsp;</td>
    <td valign=top nowrap><font size=1>
      <% = RS("FileWrite") %>
    </font></td>
    <td width=5>&nbsp;</td>
    <td valign=top><font size=1>
      <% iSize = CInt(CLng(RS("Size"))/1024) %>
      <% Response.write iSize & " " &  L_KBytes_text%>
    </font></td>
  

</tr>
<tr>
<td></td>
<td colspan=6><font size=2>
<table cellpadding=0 cellspacing=0>
<td width=30>&nbsp;</td>
<td><font size=1>
<% = RS("Description") %>
</font></td>
</tr>
</table>
</td>
</tr>
<% ' Increment the results. 
     RS.MoveNext
     RecordNum = RecordNum + 1
     Loop
%>
<% ' If query times out, display message stating that more results are available. %>
<% 
  if Q.QueryTimedOut = TRUE then 
    Response.write "<tr><td></td><td colspan=8><font size=2><b>"
    L_QueryTimedOut_error = "Not all matching messages were returned. To see all the messages, at the top of the page, click Search again."
    Response.write "&nbsp;<p>" & L_QueryTimedOut_error
    Response.write "<b></td></tr><font size=2>"
  end if 
%>

</table>

<hr>
<table cellpadding=4>
<tr><td><font size=2>

<% ' Display a More Results link if there are more results pages.

      if RS.Properties("MoreRows") = true then

           Q.StartHit = RS.Properties("NextStartHit")

         ' Repeat query with new start hit. The query must include any 
         ' custom variables you've used: in this case, Text and RecordNum.
           Response.write "<a href=search.asp?" _
             & Q.QueryToURL & "&" _
             & "Category=" & Request("Category") & "&" _
             & "DisplayText=" & Server.URLEncode(DisplayText) & "&" _
             & "RecordNum=" & RecordNum _
             & ">"
           L_MoreResults_link = "More Results" 
           Response.write L_MoreResults_link & "</a>&nbsp;&nbsp;"
      end if 
      %>
       
      <% ' Display link for a new search. %>
      <% L_NewSearch_link = "New Search" %>
      &nbsp;&nbsp;<a href="Search.asp"><% = L_NewSearch_Link %></a>

  </font></td></tr>
</table>

<% end if ' End of display of successful search results. %>
<% end if ' End of Search Results Section. %>
</font>
</body>
</html>
 
<% 
' (C) Copyright 1998 Microsoft Corporation. All Rights Reserved.
' THIS CODE AND INFORMATION IS PROVIDED "AS IS" WITHOUT WARRANTY OF
' ANY KIND, EITHER EXPRESSED OR IMPLIED, INCLUDING BUT NOT LIMITED TO
' THE IMPLIED WARRANTIES OF MERCHANTABILITY AND/OR FITNESS FOR A
' PARTICULAR PURPOSE. 
%>
